# Contributing to Beauter :cherry_blossom:

First of all, Thank you very much for choosing to help Beauter for its improvement. :innocent:

This guideline is to help you how to step in for contributing your ideas into Beauter.

## How can you help us?

Beauter is an open source project and we would love to receive any contribution or ideas from you. You can help Beauter in many ways:

- Fixing the bugs in Beauter
- Testing
- Writing Tutorials or blog posts
- Improving documentation
- Submitting Bug reports and feature requests
- Writing code that can be incorporated into Beauter itself

Please note we have a code of conduct, please follow it in all your interactions with the project.

## What is where?

- The main Beauter release for distribution is on `master` branch.
- The website and documentation is in the `gh-pages` branch.
- The current *development* branch where we release experimental stuff is in `v0.3-dev` branch.

We recommend using the *development* branch for making changes.

## Issues

While filling an issue also tell us the following:

- Make sure the issue hasn't been raised yet
- A screenshot or animated GIFs will be very helpful for understanding the issue easily.
- The version of Beauter. We assume the latest one.
- The browser you are using.
- The Code itself, any custom CSS that might be overriding.
- What did you expect?
- What did you get instead?

## Suggesting a New Feature

If you find yourself wishing for a feature that doesn't exist in Beauter yet, you are probably not alone. There are bound to be others out there with similar needs. Many of the features that Beauter has today have been added because our users saw the need. Open an issue on our issues list on GitHub which describes the feature you would like to see, why you need it, and how it should work.

## Responsibilities

- Ensure cross-browser compatibility for every change that's accepted.
- Create issues for any major changes and enhancements that you wish to make. 
- Discuss things transparently and get community feedback.
- Also, use tools like CSSLint to discover any issues with the changes you have submitted.
- Be welcoming to newcomers and encourage diverse new contributors from all backgrounds.

## Philosophy

Beauter philosophy is to provide a framework that is easy to learn and rapid to use. A human-friendly simplistic design approach from scratch while being small and fast for the internet.

Although Beauter follows BOL methodology for its design, you can read it here: http://bol.outboxcraft.com, but, contributing to Beauter is not limited by any convention, you can contribute with any approach.

## How will it get processed?

The core team will look at the submitted requests and issues and will try to resolve as soon as possible on the development branches, patches can be released in a month for the main branch.

You can chat with the core team on https://gitter.im/outboxcraft/beauter. Although we are a bit lazy, we try to reply as soon as we read.

Thank you :smile:
